<?php

namespace Treewec\Admin;

/**
 * Test class for FileMoveForm.
 * Generated by PHPUnit on 2012-06-25 at 13:15:42.
 * @group admin_fileform
 */
class FileMoveFormTest extends \PHPUnit_Framework_TestCase {

    private $formObject;

    protected function setUp() {
        $_POST['submit'] = 'submit';
    }

    public function testSuccessFileMove() {
        $fileNames = array(
            'test' => 'existing/',
            'test' => 'existing-žeš/',
            'existing-žeš' => 'existing/',
            'existing-žeš' => 'existing-žeš/',
        );

        foreach ($fileNames as $name => $newDir) {
            $oldPath = $this->getPath($name, true);
            $this->setFormAndProcess($oldPath, $newDir);
            parent::assertTrue($this->formObject->isValid());
            
            $this->setFormAndProcess(TEMP_FILEDIR .  \Treewec\FileSystem\Path::toFileSystem($newDir . $name) . '.php', '');            
            parent::assertTrue($this->formObject->isValid());
        }
    }

    public function testSuccessDirMove() {
        $fileNames = array(
            'test' => 'existing/',
            'test' => 'existing-žeš/',
            'existing-žeš' => 'existing/',
        );

        foreach ($fileNames as $name => $newDir) {
            $oldPath = $this->getPath($name, false);
            $this->setFormAndProcess($oldPath, $newDir);
            parent::assertTrue($this->formObject->isValid());
            
            $this->setFormAndProcess(TEMP_FILEDIR .  \Treewec\FileSystem\Path::toFileSystem($newDir . $name), '');
            parent::assertTrue($this->formObject->isValid());
        }
    }

    public function testMoveToSubDir() {
        $this->setFormAndProcess(TEMP_FILEDIR, 'existing/');
        parent::assertFalse($this->formObject->isValid());
    }

    public function testInvalidNewDirectory() {
        $invalid = array(
            array(), // it must be string
            '** ? dsa ///', // without invalid characters
            'unexisting/', // directory must exists in RootDirectory
            'existing-žeš/', // file cannot already exists in folder
        );
        foreach ($invalid as $invalidPath) {
            $this->setFormAndProcess(TEMP_FILEDIR . 'index.php', $invalidPath);
            parent::assertFalse($this->formObject->isValid());
        }
    }

    public function testInvalidPath() {
        $invalid = array(
            new \Exception(), // it must be string
            '** ? dsa ///', // without invalid characters
            TREEWEC_VIEW_DIR, // main publication folder cannot be moved
        );
        foreach ($invalid as $invalidPath) {
            $this->setFormAndProcess($invalidPath, 'existing/');
            parent::assertFalse($this->formObject->isValid());
        }
    }

    private function setFormAndProcess($filePath, $newFolder) {
        $this->formObject = new FileMoveForm('submit', true);
        $this->formObject->setSuccessAction(FormSuccessAction::NOTHING);
        $this->formObject->setRootDirectory(TEMP_FILEDIR);
        $_POST['new_folder'] = $newFolder;
        $this->formObject->setFilePath($filePath);
        $this->formObject->process();
    }

    private function getPath($name, $isFile) {
        $extension = $isFile ? '.php' : '';
        return TEMP_FILEDIR . \Treewec\FileSystem\Path::toFileSystem($name) . $extension;
    }

}

?>